#<profile4xi profile = "10" />
# -------------------------------------------------------------------------------------------------
#<program4xi program = "all_methods4xi.py">
#<abstract4xi abstract = "Provides function all_methods4xi" />
#<refer4xi reference = "managers.py" />
#<state4xi status = "ACK4tagging; ACK4moduletesting; NACK4systemtesting; [Rel 7.21]"/>
# -------------------------------------------------------------------------------------------------

# -------------------------------------------------------------------------------------------------
# Public API
# -------------------------------------------------------------------------------------------------
#<interface4xi interface = " 
__all__ = [ 'all_methods4xi' ]
#"
#/>

# -------------------------------------------------------------------------------------------------
# Standard Imports                          
# -------------------------------------------------------------------------------------------------
#<standardize4xi standard = "
try:                 # system ones
    import os
    import sys
    import signal
except:
    pass
try:                 # threading ones       
    import threading                
    import _thread   
except:
    pass
try:
    import _winapi
except:
    pass    
try:                 # most-common ones
    import weakref
    import array
    import queue         
except:
    pass
try:                 # rare ones
    from traceback import format_exc          
except:
    pass 
        
#"
#/>

# -------------------------------------------------------------------------------------------------
# Multiprocessing Imports                          
# -------------------------------------------------------------------------------------------------
#<process4xi process = "
try:                             # Binary ones
    import _multiprocessing
except:
    pass
try:                             # Python ones
    from multiprocessing.managers import all_methods
except:
    print("all_methods4xi.py *** failed in from multiprocessing.managers import all_methods ***")
#"
#/>
 
# -------------------------------------------------------------------------------------------------
# DragonXi imports                              
# -------------------------------------------------------------------------------------------------
#<dragonize4xi dragonization = "
from print4xi import print4xi
from time4xi import time4xi
#"
#/>


# -------------------------------------------------------------------------------------------------
#<function4xi function = "all-methods4xi" usage = "
#   managers.py
#       public_methods(obj)
#           return [name for name in all_methods(obj) if name[0] != '_']
#   private_methods4xi.py:
#       return [name2xi for name2xi in all_methods4xi(obj) if name2xi[0] == '_' or name2xi[1] == '_']
#   test_acquirerproxy4xi.py:
#       print("\n iteratorproxy4xi all methods: ", all_methods4xi(obj))
#">
#<state4xi status = "ACK4review; ACK4tagging; NACK4moduletesting; NACK4systemtesting"/>
# -------------------------------------------------------------------------------------------------
def all_methods4xi(obj):
    '''
    all_methods4xi function: returns a list of names of methods of `obj`
    '''
    # ---------------------------------------------------------------------------------------------
    #                               
    # ---------------------------------------------------------------------------------------------
    class2print = 'all_methods4xi'
    method2print = 'all_methods4xi'
    
    message2print = "{started" + "; all-methods4xi-started: " + str(all_methods4xi)  + "; time: " + time4xi() + "}"
    print4xi(class2print, method2print, message2print)       
    
    message2print = "{passed" + "; object-passed-to-all-methods4xi: " + str(obj) + "; time: " + time4xi() + "}"
    print4xi(class2print, method2print, message2print)         
    
    temp2xi = []
    
    for name2xi in dir(obj):
        
        message2print = "{set" + "; name2xi-set-by-all-methods4xi to: " + str(name2xi)  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)  
                
        try:
            function2xi = getattr(obj, name2xi)
        
            message2print = "{set" + "; function2xi-set-by-all-methods4xi to: " + str(function2xi)  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)  
            
        except:
            message2print = "{yielded" + "; object-yielded-by-all-methods4xi: " + str(obj)  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)            
        
        if hasattr(function2xi, '__call__'):
        
            message2print = "{passing" + "; name2xi-passing-to-temp2xi-append-by-all-methods4xi: " + str(name2xi) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)          
                    
            temp2xi.append(name2xi)
    
    message2print = "{returning" + "; temp2xi-returning-by-all-methods4xi: " + str(temp2xi) + "; time: " + time4xi() + "}" 
    print4xi(class2print, method2print, message2print)   
      
        
    return temp2xi

#</function4xi>
#</program4xi>

# -------------------------------------------------------------------------------------------------
# Recorded History                             
# ------------------------------------------------------------------------------------------------- 
#<record4xi record = "
#   test_none4xi.txt
#   sense-test-none4xi.xml
#   reason-test-none4xi.xml
#   ace-test-none4xi.xml
#"
#>

# -------------------------------------------------------------------------------------------------
# Legal Notice                             
# ------------------------------------------------------------------------------------------------- 
#<protect4xi protection = "copyright"
#   owner = "Small & Smart"
#   rights = "All rights reserved"
#   state = "California"
#   country = "United States of America"
#   references = "Legal notice at www.dragonxi.com; www.yourdragonxi.com; www.yourdragonxi.org; www.dragon2xi.com/; www.dragon4xi.com/; www.dragon8xi.com/ " 
#   codes = "Codes established in California and applicable to corporations in California"
#   compliance = "The California Law"
#   court = "Supreme Court of California, 350 McAllister Street, San Francisco, CA 94102-4783"
#/>
 
#<end4xi end = "
# -------------------------------------------------------------------------------------------------
# end of all_methods4xi.py                           
# ------------------------------------------------------------------------------------------------- 
#"
#/>


